
{-# LANGUAGE NoImplicitPrelude       #-}

module Main where

import Data.Set as Set
import Data.String.Conversions (cs)
import Data.Text (Text)
import Graph.BAC.Clustering
import Graph.Dataset
import Graph.Lib.FGL
import Graph.Tools.Import
import Graph.Tools.Random
import Graph.Types
import Prelude (String)
import Protolude
import Test.Hspec
import qualified Data.IntMap        as Dict
import qualified Data.List          as List
import qualified Eigen.Matrix       as Matrix
import qualified Eigen.SparseMatrix as SMatrix
import qualified Prelude            as Prelude


main :: IO ()
main = hspec $ do
  describe "Graph Toy first test" $ do
    it "Graph Toy test exact result [1/2]" $ do
      shouldBe True (g_toy_0_result == getClusters Optim 3 g_toy_0)

    it "Graph G Toy test exact result [2/2]" $ do
      shouldBe True (g_toy_result == ( getClusters Safe 3
                                     $ LightWeightedGraph
                                     $ mkLGraphfromEdges g_toy
                                     )
                    )

    it "Graph Zachary" $ do
      shouldBe True (graph_zachary_clustering == (getClusters Safe 3 graph_zachary ))

    it "Graph Jouer" $ do
      shouldBe True (graph_jouer_clustering == (getClusters Safe 3 graph_jouer ))



{-
  m <- randomAdjacency
  describe "Random Matrix of fixed size (TODO dynamic size)" $ do
    let
      g :: Graph () ()
      g = mkGraphUfromEdges
        $ List.map (\(x,y,_) -> (x,y))
        $ SMatrix.toList m
      result = withG g (parts  . (clusteringOptim 3 Conf))
    it "Random test, checking clustering size" $ do
      shouldBe True (let n = (Dict.size result) in n > 1 && n < 10)
-}
